library vector2d;

import 'dart:math';

abstract class Abstract2DVector<N extends num> {
	N get x;
	N get y;
	set x( N value ){}
	set y( N value ){}

	double get angle { if( x == 0 && y == 0 ) return 0.0; else return atan2( y, x ); }

	N get length2 => x * x + y * y;
	double get length => sqrt( length2 );
	int get intLength => length.toInt();
}